Attribute VB_Name = "modCallback"
Option Explicit

'---- Win32 API function declarations
Declare Function EnumWindows Lib "user32" _
    (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Declare Function GetWindowText Lib "user32" Alias _
    "GetWindowTextA" (ByVal hwnd As Long, _
    ByVal lpString As String, ByVal cch As Long) As Long
Declare Function GetWindowTextLength Lib "user32" Alias _
    "GetWindowTextLengthA" (ByVal hwnd As Long) As Long

'---- Starts enumeration
Public Sub Enumerate()
    EnumWindows AddressOf EnumWindowsProc, 0
End Sub

'---- Enumeration callback procedure
Private Function EnumWindowsProc(ByVal hwnd As Long, _
    ByVal lParam As Long) As Boolean
    ' Get Window text
    Dim sTxt As String
    sTxt = String(GetWindowTextLength(hwnd) + 1, Chr(0))
    GetWindowText hwnd, sTxt, Len(sTxt)
    ' Add to the list
    frmMain.lstWindows.AddItem Left(sTxt, Len(sTxt) - 1) _
        & " (" & Hex(hwnd) & ")"
    ' Return True to proceed with enumeration
    EnumWindowsProc = True
End Function
